Class SBHealingGun extends PulseGun;


#exec TEXTURE IMPORT NAME=HGMuzzyPulse FILE=Textures\HGMuzzyPulse.bmp GROUP="Skins"
#exec TEXTURE IMPORT NAME=HGTex FILE=Textures\HealingGunTex.pcx GROUP="Skins"


#exec AUDIO IMPORT FILE="Sounds\HGgundown.wav" NAME="HGgundown"
#exec AUDIO IMPORT FILE="Sounds\HGaltfire.wav" NAME="HGaltfire"
#exec AUDIO IMPORT FILE="Sounds\HGpickup.wav" NAME="HGpickup"
#exec AUDIO IMPORT FILE="Sounds\HGgunup.wav" NAME="HGgunup"
#exec AUDIO IMPORT FILE="Sounds\HGPulseFire.wav" NAME="HGPulseFire"

#exec TEXTURE IMPORT NAME=HGIconPulse FILE=TEXTURES\HGIconPulse.bmp GROUP="Icons" MIPS=OFF
#exec TEXTURE IMPORT NAME=HGUsePulse FILE=TEXTURES\HGUsePulse.bmp GROUP="Icons" MIPS=OFF

var() bool	bHealTeamMembersOnly;
var() int	HealingAmount;
var() int	MaxHealth; // healing only until this maximum
// does not work: var() bool	bRestoreAttitudeToPlayerOnHealing; // only operative if bHealTeamMembersOnly==False

var() bool	bMakeMonstersWaitingWhileHealing; // only operative if bHealTeamMembersOnly==False


var int TimeForNextHealMessage;
var float CheckTimer;



replication {
	// Things the server should send to the client. Not really needed, but other code can get changed default settings.
	reliable if ( Role == ROLE_Authority )
		bHealTeamMembersOnly, HealingAmount, MaxHealth /*, bRestoreAttitudeToPlayerOnHealing */;
}



function bool CanSendHealMessage() {
/******************************************************************************
Introduced to avoid spammy message with every tick.
******************************************************************************/
	if (TimeForNextHealMessage < Level.TimeSeconds)
	{
		TimeForNextHealMessage = Level.TimeSeconds + 2;
		return true;
	}
	return false;
}



function MyTimer() {
// initial code contributed by SeriousBuggie
Local Pawn P;
local Bot Bot;
local name BotState;

	Bot = Bot(Owner);
	if (Bot == None
		|| Bot.Weapon != self
		|| Bot.PlayerReplicationInfo == None
		|| (Bot.Enemy != None && Bot.Enemy != Bot)
		|| CTFFlag(Bot.Target) != None
		|| Bot.PlayerReplicationInfo.HasFlag != None)
		return;
	BotState = Bot.GetStateName();
	if (BotState == 'RangedAttack' || BotState == 'FallingState' || BotState == 'TakeHit' || BotState == 'ImpactJumping')
		return;

	for (P = Level.PawnList; P != None; P = P.nextPawn)
		if (P != Bot
			&& P.PlayerReplicationInfo != None
			&& P.PlayerReplicationInfo.Team == Bot.PlayerReplicationInfo.Team
			&& P.Health < MaxHealth
			&& VSize(P.Location - Bot.Location) - P.CollisionRadius < 710
			&& Bot.LineOfSightTo(P))
		{
			Bot.Enemy = Bot; // weird hack
			Bot.Target = P;
			Bot.bComboPaused = true;
			Bot.SpecialPause = 1.0; // calculate exact time for heal
			Bot.NextState = BotState;
			Bot.NextLabel = 'Begin';
			Bot.GotoState('RangedAttack');
			break;
		}
	if (P == None && Bot.Enemy == Bot)
		Bot.Enemy = None; // reset hack
}



function PostBeginPlay() {
local class<Actor> CheckAltProjectileClass;

	Super.PostBeginPlay();
	CheckAltProjectileClass = class<Actor>(DynamicLoadObject(string(AltProjectileClass), class'Class'));
	if ( ! ((CheckAltProjectileClass != None) && ClassIsChildOf(CheckAltProjectileClass, class'HGStarterbolt')))
	{
		AltProjectileClass = Class'HGStarterbolt';
		warn("You must not change the AltProjectileClass for" @ self $ ". AltProjectileClass reset to" @ AltProjectileClass);
	}
}



function Projectile ProjectileFire(class<projectile> ProjClass, float ProjSpeed, bool bWarn) {
local Projectile Proj;
	Proj = Super.ProjectileFire(ProjClass, ProjSpeed, bWarn);
	if (Proj != None)
		if (Proj.Owner == None)
			Proj.SetOwner(Self);
	return Proj;
}



function float RateSelf(out int bUseAltMode) {
// code contributed by SeriousBuggie
local int Ignored;
local Bot Bot;

	Bot = Bot(Owner);
	if (Bot != None
		&& Bot.bComboPaused
		&& Bot.Enemy == Bot
		&& Pawn(Bot.Target) != None
		&& Pawn(Bot.Target).PlayerReplicationInfo != None
		&& Bot.PlayerReplicationInfo != None
		&& Bot.PlayerReplicationInfo.Team == Pawn(Bot.Target).PlayerReplicationInfo.Team)
	{
		bUseAltMode = 1; // do special heal
		return 10;
	}
	bUseAltMode = 0; // never use for Bot.
	return Super.RateSelf(Ignored);
}



simulated event RenderOverlays(canvas Canvas) {
/******************************************************************************
Show ammo amount on side of weapon.
******************************************************************************/
	MultiSkins[1] = Texture'Ammoled';
	Texture'Ammoled'.NotifyActor = Self;
	Super.RenderOverlays(Canvas);
	Texture'Ammoled'.NotifyActor = None;
	MultiSkins[1] = Default.MultiSkins[1];
}



function inventory SpawnCopy(pawn Other) {
local inventory result;
	result = Super.SpawnCopy(Other);
	if (SBHealingGun(result) != None)
	{
		SBHealingGun(result).HealingAmount = HealingAmount;
		SBHealingGun(result).bHealTeamMembersOnly = bHealTeamMembersOnly;
		SBHealingGun(result).MaxHealth = MaxHealth;
	}
	Return Result;
}



function Tick(float delta) {
// code contributed by SeriousBuggie
	Super.Tick(delta);

	if (CheckTimer <= Level.TimeSeconds)
	{
		CheckTimer = Level.TimeSeconds + 0.51;
		MyTimer();
	}
}



defaultproperties {
	AIRating=0.9
	AltFireSound=Sound'PulseBolt2'
	AltProjectileClass=Class'HGStarterbolt'
	bHealTeamMembersOnly=true
	bMakeMonstersWaitingWhileHealing=true
	CollisionHeight=16
	DownSound=Sound'HGgundown'
	FireSound=Sound'HGPulseFire'
	HealingAmount=1
	Icon=Texture'HGUsePulse'
	ItemName="Healing Gun"
	MaxHealth=500
	MultiSkins(1)=Texture'HGTex'
	MultiSkins(2)=Texture'HGTex'
	MuzzleFlashTexture=Texture'HGMuzzyPulse'
	NameColor=(R=128,G=255,B=128)
	PickupMessage="You got a Healing Gun"
	PickupSound=Sound'HGpickup'
	ProjectileClass=Class'HGPlasmaSphere'
	SelectSound=Sound'HGgunup'
	StatusIcon=Texture'HGUsePulse'
	WeaponDescription="Classification: Plasma Rifle\\n\\nPrimary Fire: Medium sized, fast moving plasma balls are fired at a fast rate of fire.\\n\\nSecondary Fire: A bolt of red is expelled for 100 meters, which will heal all teammates.\\n\\nTechniques: Firing and keeping the secondary fire's beam on a teammate will heal them in seconds."
}
